/*----------------------------------------------------------------------------*/
/* app.c - application dependent routines, change these for different problem
 */
/*----------------------------------------------------------------------------*/

#include <math.h>
#include "external.h"

void
application ()
/* this routine should contain any application-dependent computations */
/* that should be performed before each EP cycle. called by main()    */
{
}


void
app_data ()
/* application dependent data input, called by init_data() */
/* ask your input questions here, and put output in global variables */
{
}


void
app_free ()
/* application dependent free() calls, called by freeall() */
{
}


void
app_init ()
/* application dependent initialization routine called by intialize() */
{
}


void
app_initreport ()
/* Application-dependent initial report called by initialize() */
{
}


void
app_malloc ()
/* application dependent malloc() calls, called by initmalloc() */
{
  char *malloc ();
}


void
app_report ()
/* Application-dependent report, called by report() */
{
}


void
app_stats (pop)
/* Application-dependent statistics calculations called by statistics() */
     struct individual *pop;
{
}


void
objfunc (critter)
     struct individual *critter;
{
  double x1, x2, x3;

  critter->fitness = 0.0;

  x1 = critter->chrom[0];
  x2 = critter->chrom[1];
/*  x3 = critter->chrom[2];    */

/*     critter->fitness = (x1*x1) + (x2*x2) + (x3*x3); */

/* Rosenbrock Function */
/*  critter->fitness = 100.0*(x1*x1-x2)*(x1*x1-x2)+ (1.0-x1)*(1.0-x1);     */

/* Bohachevsky function */
  critter->fitness = (x1 * x1) + 2 * (x2 * x2);
  critter->fitness += -0.3 * cos (3.0 * 3.141592 * x1)
    - 0.4 * cos (4.0 * 3.141592 * x2) + 0.7;
}
