/* ep.h - global declarations for main(), all variable declared herein must
          also be defined as extern variables in external.h !!! */

#include <stdio.h>

/* file pointers */
FILE *outfp, *infp;

/* Global structures and variables */
struct individual
  {
    double *chrom;		/* chromosome string for the individual */
    double fitness;		/* fitness of the individual */
    int index;			/* Index to store no. of wins */
  };

struct bestever
  {
    double *chrom;		/* chromosome string for the best-ever individual */
    double fitness;		/* fitness of the best-ever individual */
    int generation;		/* generation which produced it */
  };

struct individual *oldpop;	/* last generation of individuals */
struct individual *newpop;	/* next generation of individuals */
struct individual *temppop;	/* temp. pop between oldpop and newpop? */
struct bestever bestfit;	/* fittest individual so far */
double sumfitness;		/* summed fitness for entire population */
double max;			/* maximum fitness of population */
double avg;			/* average fitness of population */
double min;			/* minumum fitness of population */
double inirange;		/* initial range for initializing the chrom */
double scalefactor;		/* scaling factor for the mutation */
double offset;			/* offset factor for mutation */
int lchrom;			/* length of chromosome per individual */
int numfiles;			/* number of open files */
int popsize;			/* population size */
int gen;			/* current generation number */
int maxgen;			/* maximum generation number */
int run;			/* current run number */
int maxruns;			/* maximum number of runs to make */

/* Include function prototypes for ANSI C checking */
#include "proto.h"

/* Application-dependent declarations go after here... */
